Index: uspace/drv/test/test1/test1.c
===================================================================
--- uspace/drv/test/test1/test1.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/test/test1/test1.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -37,13 +37,12 @@
 #include <ddf/driver.h>
 #include <ddf/log.h>
-#include <str.h>
 
 #include "test1.h"
 
-static errno_t test1_dev_add(ddf_dev_t *dev);
-static errno_t test1_dev_remove(ddf_dev_t *dev);
-static errno_t test1_dev_gone(ddf_dev_t *dev);
-static errno_t test1_fun_online(ddf_fun_t *fun);
-static errno_t test1_fun_offline(ddf_fun_t *fun);
+static int test1_dev_add(ddf_dev_t *dev);
+static int test1_dev_remove(ddf_dev_t *dev);
+static int test1_dev_gone(ddf_dev_t *dev);
+static int test1_fun_online(ddf_fun_t *fun);
+static int test1_fun_offline(ddf_fun_t *fun);
 
 static driver_ops_t driver_ops = {
@@ -74,10 +73,10 @@
  * @param score Device match score.
  */
-static errno_t register_fun_verbose(ddf_dev_t *parent, const char *message,
+static int register_fun_verbose(ddf_dev_t *parent, const char *message,
     const char *name, const char *match_id, int match_score,
-    errno_t expected_rc, ddf_fun_t **pfun)
+    int expected_rc, ddf_fun_t **pfun)
 {
 	ddf_fun_t *fun = NULL;
-	errno_t rc;
+	int rc;
 
 	ddf_msg(LVL_DEBUG, "Registering function `%s': %s.", name, message);
@@ -142,10 +141,10 @@
  * @return Error code reporting success of the operation.
  */
-static errno_t test1_dev_add(ddf_dev_t *dev)
+static int test1_dev_add(ddf_dev_t *dev)
 {
 	ddf_fun_t *fun_a;
 	test1_t *test1;
 	const char *dev_name;
-	errno_t rc;
+	int rc;
 
 	dev_name = ddf_dev_get_name(dev);
@@ -197,7 +196,7 @@
 }
 
-static errno_t fun_remove(ddf_fun_t *fun, const char *name)
-{
-	errno_t rc;
+static int fun_remove(ddf_fun_t *fun, const char *name)
+{
+	int rc;
 
 	ddf_msg(LVL_DEBUG, "fun_remove(%p, '%s')", fun, name);
@@ -218,7 +217,7 @@
 }
 
-static errno_t fun_unbind(ddf_fun_t *fun, const char *name)
-{
-	errno_t rc;
+static int fun_unbind(ddf_fun_t *fun, const char *name)
+{
+	int rc;
 
 	ddf_msg(LVL_DEBUG, "fun_unbind(%p, '%s')", fun, name);
@@ -233,8 +232,8 @@
 }
 
-static errno_t test1_dev_remove(ddf_dev_t *dev)
+static int test1_dev_remove(ddf_dev_t *dev)
 {
 	test1_t *test1 = (test1_t *)ddf_dev_data_get(dev);
-	errno_t rc;
+	int rc;
 
 	ddf_msg(LVL_DEBUG, "test1_dev_remove(%p)", dev);
@@ -261,8 +260,8 @@
 }
 
-static errno_t test1_dev_gone(ddf_dev_t *dev)
+static int test1_dev_gone(ddf_dev_t *dev)
 {
 	test1_t *test1 = (test1_t *)ddf_dev_data_get(dev);
-	errno_t rc;
+	int rc;
 
 	ddf_msg(LVL_DEBUG, "test1_dev_remove(%p)", dev);
@@ -289,5 +288,5 @@
 }
 
-static errno_t test1_fun_online(ddf_fun_t *fun)
+static int test1_fun_online(ddf_fun_t *fun)
 {
 	ddf_msg(LVL_DEBUG, "test1_fun_online()");
@@ -295,5 +294,5 @@
 }
 
-static errno_t test1_fun_offline(ddf_fun_t *fun)
+static int test1_fun_offline(ddf_fun_t *fun)
 {
 	ddf_msg(LVL_DEBUG, "test1_fun_offline()");
Index: uspace/drv/test/test2/test2.c
===================================================================
--- uspace/drv/test/test2/test2.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/test/test2/test2.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -34,5 +34,4 @@
 #include <stdio.h>
 #include <errno.h>
-#include <str.h>
 #include <str_error.h>
 #include <ddf/driver.h>
@@ -41,9 +40,9 @@
 #define NAME "test2"
 
-static errno_t test2_dev_add(ddf_dev_t *dev);
-static errno_t test2_dev_remove(ddf_dev_t *dev);
-static errno_t test2_dev_gone(ddf_dev_t *dev);
-static errno_t test2_fun_online(ddf_fun_t *fun);
-static errno_t test2_fun_offline(ddf_fun_t *fun);
+static int test2_dev_add(ddf_dev_t *dev);
+static int test2_dev_remove(ddf_dev_t *dev);
+static int test2_dev_gone(ddf_dev_t *dev);
+static int test2_fun_online(ddf_fun_t *fun);
+static int test2_fun_offline(ddf_fun_t *fun);
 
 static driver_ops_t driver_ops = {
@@ -78,9 +77,9 @@
  * @param score Device match score.
  */
-static errno_t register_fun_verbose(ddf_dev_t *parent, const char *message,
+static int register_fun_verbose(ddf_dev_t *parent, const char *message,
     const char *name, const char *match_id, int match_score, ddf_fun_t **pfun)
 {
 	ddf_fun_t *fun;
-	errno_t rc;
+	int rc;
 
 	ddf_msg(LVL_DEBUG, "Registering function `%s': %s.", name, message);
@@ -119,9 +118,9 @@
  * @return Always EOK.
  */
-static errno_t plug_unplug(void *arg)
+static int plug_unplug(void *arg)
 {
 	test2_t *test2 = (test2_t *) arg;
 	ddf_fun_t *fun_a;
-	errno_t rc;
+	int rc;
 
 	async_usleep(1000);
@@ -158,7 +157,7 @@
 }
 
-static errno_t fun_remove(ddf_fun_t *fun, const char *name)
-{
-	errno_t rc;
+static int fun_remove(ddf_fun_t *fun, const char *name)
+{
+	int rc;
 
 	ddf_msg(LVL_DEBUG, "fun_remove(%p, '%s')", fun, name);
@@ -179,7 +178,7 @@
 }
 
-static errno_t fun_unbind(ddf_fun_t *fun, const char *name)
-{
-	errno_t rc;
+static int fun_unbind(ddf_fun_t *fun, const char *name)
+{
+	int rc;
 
 	ddf_msg(LVL_DEBUG, "fun_unbind(%p, '%s')", fun, name);
@@ -194,5 +193,5 @@
 }
 
-static errno_t test2_dev_add(ddf_dev_t *dev)
+static int test2_dev_add(ddf_dev_t *dev)
 {
 	test2_t *test2;
@@ -225,8 +224,8 @@
 }
 
-static errno_t test2_dev_remove(ddf_dev_t *dev)
+static int test2_dev_remove(ddf_dev_t *dev)
 {
 	test2_t *test2 = (test2_t *)ddf_dev_data_get(dev);
-	errno_t rc;
+	int rc;
 
 	ddf_msg(LVL_DEBUG, "test2_dev_remove(%p)", dev);
@@ -259,8 +258,8 @@
 }
 
-static errno_t test2_dev_gone(ddf_dev_t *dev)
+static int test2_dev_gone(ddf_dev_t *dev)
 {
 	test2_t *test2 = (test2_t *)ddf_dev_data_get(dev);
-	errno_t rc;
+	int rc;
 
 	ddf_msg(LVL_DEBUG, "test2_dev_gone(%p)", dev);
@@ -294,5 +293,5 @@
 
 
-static errno_t test2_fun_online(ddf_fun_t *fun)
+static int test2_fun_online(ddf_fun_t *fun)
 {
 	ddf_msg(LVL_DEBUG, "test2_fun_online()");
@@ -300,5 +299,5 @@
 }
 
-static errno_t test2_fun_offline(ddf_fun_t *fun)
+static int test2_fun_offline(ddf_fun_t *fun)
 {
 	ddf_msg(LVL_DEBUG, "test2_fun_offline()");
Index: uspace/drv/test/test3/test3.c
===================================================================
--- uspace/drv/test/test3/test3.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/test/test3/test3.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -41,8 +41,8 @@
 #define NUM_FUNCS 20
 
-static errno_t test3_dev_add(ddf_dev_t *dev);
-static errno_t test3_dev_remove(ddf_dev_t *dev);
-static errno_t test3_fun_online(ddf_fun_t *fun);
-static errno_t test3_fun_offline(ddf_fun_t *fun);
+static int test3_dev_add(ddf_dev_t *dev);
+static int test3_dev_remove(ddf_dev_t *dev);
+static int test3_fun_online(ddf_fun_t *fun);
+static int test3_fun_offline(ddf_fun_t *fun);
 
 static driver_ops_t driver_ops = {
@@ -63,15 +63,15 @@
 } test3_t;
 
-static errno_t register_fun_and_add_to_category(ddf_dev_t *parent,
+static int register_fun_and_add_to_category(ddf_dev_t *parent,
     const char *base_name, size_t index, const char *class_name,
     ddf_fun_t **pfun)
 {
 	ddf_fun_t *fun = NULL;
-	errno_t rc;
+	int rc;
 	char *fun_name = NULL;
 	
-	if (asprintf(&fun_name, "%s%zu", base_name, index) < 0) {
-		ddf_msg(LVL_ERROR, "Failed to format string: No memory");
-		rc = ENOMEM;
+	rc = asprintf(&fun_name, "%s%zu", base_name, index);
+	if (rc < 0) {
+		ddf_msg(LVL_ERROR, "Failed to format string: %s", str_error(rc));
 		goto leave;
 	}
@@ -106,7 +106,7 @@
 }
 
-static errno_t fun_remove(ddf_fun_t *fun, const char *name)
+static int fun_remove(ddf_fun_t *fun, const char *name)
 {
-	errno_t rc;
+	int rc;
 
 	ddf_msg(LVL_DEBUG, "fun_remove(%p, '%s')", fun, name);
@@ -127,7 +127,7 @@
 }
 
-static errno_t test3_dev_add(ddf_dev_t *dev)
+static int test3_dev_add(ddf_dev_t *dev)
 {
-	errno_t rc = EOK;
+	int rc = EOK;
 	test3_t *test3;
 
@@ -153,14 +153,15 @@
 }
 
-static errno_t test3_dev_remove(ddf_dev_t *dev)
+static int test3_dev_remove(ddf_dev_t *dev)
 {
 	test3_t *test3 = (test3_t *)ddf_dev_data_get(dev);
 	char *fun_name;
-	errno_t rc;
+	int rc;
 	size_t i;
 
 	for (i = 0; i < NUM_FUNCS; i++) {
-		if (asprintf(&fun_name, "test3_%zu", i) < 0) {
-			ddf_msg(LVL_ERROR, "Failed to format string: No memory");
+		rc = asprintf(&fun_name, "test3_%zu", i);
+		if (rc < 0) {
+			ddf_msg(LVL_ERROR, "Failed to format string: %s", str_error(rc));
 			return ENOMEM;
 		}
@@ -176,5 +177,5 @@
 }
 
-static errno_t test3_fun_online(ddf_fun_t *fun)
+static int test3_fun_online(ddf_fun_t *fun)
 {
 	ddf_msg(LVL_DEBUG, "test3_fun_online()");
@@ -182,5 +183,5 @@
 }
 
-static errno_t test3_fun_offline(ddf_fun_t *fun)
+static int test3_fun_offline(ddf_fun_t *fun)
 {
 	ddf_msg(LVL_DEBUG, "test3_fun_offline()");
Index: uspace/drv/time/cmos-rtc/cmos-rtc.c
===================================================================
--- uspace/drv/time/cmos-rtc/cmos-rtc.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/time/cmos-rtc/cmos-rtc.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -80,13 +80,13 @@
 static rtc_t *dev_rtc(ddf_dev_t *dev);
 static rtc_t *fun_rtc(ddf_fun_t *fun);
-static errno_t
+static int
 rtc_battery_status_get(ddf_fun_t *fun, battery_status_t *status);
-static errno_t  rtc_time_get(ddf_fun_t *fun, struct tm *t);
-static errno_t  rtc_time_set(ddf_fun_t *fun, struct tm *t);
-static errno_t  rtc_dev_add(ddf_dev_t *dev);
-static errno_t  rtc_dev_initialize(rtc_t *rtc);
+static int  rtc_time_get(ddf_fun_t *fun, struct tm *t);
+static int  rtc_time_set(ddf_fun_t *fun, struct tm *t);
+static int  rtc_dev_add(ddf_dev_t *dev);
+static int  rtc_dev_initialize(rtc_t *rtc);
 static bool rtc_pio_enable(rtc_t *rtc);
 static void rtc_dev_cleanup(rtc_t *rtc);
-static errno_t  rtc_open(ddf_fun_t *fun);
+static int  rtc_open(ddf_fun_t *fun);
 static void rtc_close(ddf_fun_t *fun);
 static bool rtc_update_in_progress(rtc_t *rtc);
@@ -94,9 +94,9 @@
 static unsigned bcd2bin(unsigned bcd);
 static unsigned bin2bcd(unsigned binary);
-static errno_t rtc_dev_remove(ddf_dev_t *dev);
+static int rtc_dev_remove(ddf_dev_t *dev);
 static void rtc_register_write(rtc_t *rtc, int reg, int data);
 static bool is_battery_ok(rtc_t *rtc);
-static errno_t  rtc_fun_online(ddf_fun_t *fun);
-static errno_t  rtc_fun_offline(ddf_fun_t *fun);
+static int  rtc_fun_online(ddf_fun_t *fun);
+static int  rtc_fun_offline(ddf_fun_t *fun);
 
 static ddf_dev_ops_t rtc_dev_ops;
@@ -190,10 +190,10 @@
  * @param rtc  Pointer to the RTC device
  *
- * @return  EOK on success or an error code
+ * @return  EOK on success or a negative error code
  */ 
-static errno_t
+static int
 rtc_dev_initialize(rtc_t *rtc)
 {
-	errno_t rc;
+	int rc;
 	size_t i;
 	hw_resource_t *res;
@@ -314,7 +314,7 @@
  * @param t    Pointer to the time variable
  *
- * @return  EOK on success or an error code
- */
-static errno_t
+ * @return  EOK on success or a negative error code
+ */
+static int
 rtc_time_get(ddf_fun_t *fun, struct tm *t)
 {
@@ -412,5 +412,5 @@
 	/* Try to normalize the content of the tm structure */
 	time_t r = mktime(t);
-	errno_t result;
+	int result;
 
 	if (r < 0)
@@ -436,7 +436,7 @@
  * @param t    The time value to set
  *
- * @return  EOK or an error code
- */
-static errno_t
+ * @return  EOK or a negative error code
+ */
+static int
 rtc_time_set(ddf_fun_t *fun, struct tm *t)
 {
@@ -544,7 +544,7 @@
  * @param status The status of the battery
  *
- * @return       EOK on success or an error code
- */
-static errno_t
+ * @return       EOK on success or a negative error code
+ */
+static int
 rtc_battery_status_get(ddf_fun_t *fun, battery_status_t *status)
 {
@@ -577,12 +577,12 @@
  * @param dev  The RTC device
  *
- * @return  EOK on success or an error code
- */
-static errno_t
+ * @return  EOK on success or a negative error code
+ */
+static int
 rtc_dev_add(ddf_dev_t *dev)
 {
 	rtc_t *rtc;
 	ddf_fun_t *fun = NULL;
-	errno_t rc;
+	int rc;
 	bool need_cleanup = false;
 
@@ -643,11 +643,11 @@
  * @param dev   The RTC device
  *
- * @return      EOK on success or an error code
- */
-static errno_t
+ * @return      EOK on success or a negative error code
+ */
+static int
 rtc_dev_remove(ddf_dev_t *dev)
 {
 	rtc_t *rtc = dev_rtc(dev);
-	errno_t rc;
+	int rc;
 
 	fibril_mutex_lock(&rtc->mutex);
@@ -682,10 +682,10 @@
  * @param fun   The function node
  *
- * @return  EOK on success or an error code
- */
-static errno_t
+ * @return  EOK on success or a negative error code
+ */
+static int
 rtc_open(ddf_fun_t *fun)
 {
-	errno_t rc;
+	int rc;
 	rtc_t *rtc = fun_rtc(fun);
 
@@ -744,8 +744,8 @@
 }
 
-static errno_t
+static int
 rtc_fun_online(ddf_fun_t *fun)
 {
-	errno_t rc;
+	int rc;
 
 	ddf_msg(LVL_DEBUG, "rtc_fun_online()");
@@ -758,5 +758,5 @@
 }
 
-static errno_t
+static int
 rtc_fun_offline(ddf_fun_t *fun)
 {
Index: uspace/lib/bithenge/include/bithenge/blob.h
===================================================================
--- uspace/lib/bithenge/include/bithenge/blob.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/bithenge/include/bithenge/blob.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -53,10 +53,10 @@
 typedef struct bithenge_random_access_blob_ops_t {
 	/** @copydoc bithenge_blob_t::bithenge_blob_size */
-	errno_t (*size)(bithenge_blob_t *self, aoff64_t *size);
+	int (*size)(bithenge_blob_t *self, aoff64_t *size);
 	/** @copydoc bithenge_blob_t::bithenge_blob_read */
-	errno_t (*read)(bithenge_blob_t *self, aoff64_t offset, char *buffer,
+	int (*read)(bithenge_blob_t *self, aoff64_t offset, char *buffer,
 	    aoff64_t *size);
 	/** @copydoc bithenge_blob_t::bithenge_blob_read_bits */
-	errno_t (*read_bits)(bithenge_blob_t *self, aoff64_t offset, char *buffer,
+	int (*read_bits)(bithenge_blob_t *self, aoff64_t offset, char *buffer,
 	    aoff64_t *size, bool little_endian);
 	/** Destroy the blob.
@@ -94,5 +94,5 @@
 	 * @return EOK on success or an error code from errno.h.
 	 */
-	errno_t (*size)(bithenge_sequential_blob_t *self, aoff64_t *size);
+	int (*size)(bithenge_sequential_blob_t *self, aoff64_t *size);
 
 	/** Read the next part of the blob. If the requested data extends
@@ -108,5 +108,5 @@
 	 * @return EOK on success or an error code from errno.h.
 	 */
-	errno_t (*read)(bithenge_sequential_blob_t *self, char *buffer,
+	int (*read)(bithenge_sequential_blob_t *self, char *buffer,
 	    aoff64_t *size);
 
@@ -123,5 +123,5 @@
  * @return EOK on success or an error code from errno.h.
  */
-static inline errno_t bithenge_blob_size(bithenge_blob_t *self, aoff64_t *size)
+static inline int bithenge_blob_size(bithenge_blob_t *self, aoff64_t *size)
 {
 	assert(self);
@@ -145,5 +145,5 @@
  * @return EOK on success or an error code from errno.h.
  */
-static inline errno_t bithenge_blob_read(bithenge_blob_t *self, aoff64_t offset,
+static inline int bithenge_blob_read(bithenge_blob_t *self, aoff64_t offset,
     char *buffer, aoff64_t *size)
 {
@@ -173,5 +173,5 @@
  * @return EOK on success or an error code from errno.h.
  */
-static inline errno_t bithenge_blob_read_bits(bithenge_blob_t *self,
+static inline int bithenge_blob_read_bits(bithenge_blob_t *self,
     aoff64_t offset, char *buffer, aoff64_t *size, bool little_endian)
 {
@@ -190,10 +190,10 @@
  * @param[out] out Holds whether the blob is empty.
  * @return EOK on success or an error code from errno.h. */
-static inline errno_t bithenge_blob_empty(bithenge_blob_t *self, bool *out)
+static inline int bithenge_blob_empty(bithenge_blob_t *self, bool *out)
 {
 	assert(self);
 	assert(self->base.blob_ops);
 	aoff64_t size;
-	errno_t rc = bithenge_blob_size(self, &size);
+	int rc = bithenge_blob_size(self, &size);
 	*out = size == 0;
 	return rc;
@@ -235,19 +235,19 @@
 
 /** @memberof bithenge_blob_t */
-errno_t bithenge_init_random_access_blob(bithenge_blob_t *,
+int bithenge_init_random_access_blob(bithenge_blob_t *,
     const bithenge_random_access_blob_ops_t *);
 /** @memberof bithenge_sequential_blob_t */
-errno_t bithenge_init_sequential_blob(bithenge_sequential_blob_t *,
+int bithenge_init_sequential_blob(bithenge_sequential_blob_t *,
     const bithenge_sequential_blob_ops_t *);
 /** @memberof bithenge_blob_t */
-errno_t bithenge_new_blob_from_data(bithenge_node_t **, const void *, size_t);
-/** @memberof bithenge_blob_t */
-errno_t bithenge_new_blob_from_buffer(bithenge_node_t **, const void *, size_t,
+int bithenge_new_blob_from_data(bithenge_node_t **, const void *, size_t);
+/** @memberof bithenge_blob_t */
+int bithenge_new_blob_from_buffer(bithenge_node_t **, const void *, size_t,
     bool);
-errno_t bithenge_new_offset_blob(bithenge_node_t **, bithenge_blob_t *, aoff64_t);
-errno_t bithenge_new_subblob(bithenge_node_t **, bithenge_blob_t *, aoff64_t,
+int bithenge_new_offset_blob(bithenge_node_t **, bithenge_blob_t *, aoff64_t);
+int bithenge_new_subblob(bithenge_node_t **, bithenge_blob_t *, aoff64_t,
     aoff64_t);
 /** @memberof bithenge_blob_t */
-errno_t bithenge_blob_equal(bool *, bithenge_blob_t *, bithenge_blob_t *);
+int bithenge_blob_equal(bool *, bithenge_blob_t *, bithenge_blob_t *);
 
 #endif
Index: uspace/lib/bithenge/include/bithenge/compound.h
===================================================================
--- uspace/lib/bithenge/include/bithenge/compound.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/bithenge/include/bithenge/compound.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -41,9 +41,9 @@
 #include "transform.h"
 
-errno_t bithenge_new_composed_transform(bithenge_transform_t **,
+int bithenge_new_composed_transform(bithenge_transform_t **,
     bithenge_transform_t **, size_t);
-errno_t bithenge_if_transform(bithenge_transform_t **, bithenge_expression_t *,
+int bithenge_if_transform(bithenge_transform_t **, bithenge_expression_t *,
     bithenge_transform_t *, bithenge_transform_t *);
-errno_t bithenge_partial_transform(bithenge_transform_t **,
+int bithenge_partial_transform(bithenge_transform_t **,
     bithenge_transform_t *);
 
Index: uspace/lib/bithenge/include/bithenge/expression.h
===================================================================
--- uspace/lib/bithenge/include/bithenge/expression.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/bithenge/include/bithenge/expression.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -52,5 +52,5 @@
 typedef struct bithenge_expression_ops {
 	/** @copydoc bithenge_expression_t::bithenge_expression_evaluate */
-	errno_t (*evaluate)(bithenge_expression_t *self, bithenge_scope_t *scope,
+	int (*evaluate)(bithenge_expression_t *self, bithenge_scope_t *scope,
 	    bithenge_node_t **out);
 	/** Destroy the expression.
@@ -85,5 +85,5 @@
  * @param[out] out Where the output tree will be stored.
  * @return EOK on success or an error code from errno.h. */
-static inline errno_t bithenge_expression_evaluate(bithenge_expression_t *self,
+static inline int bithenge_expression_evaluate(bithenge_expression_t *self,
     bithenge_scope_t *scope, bithenge_node_t **out)
 {
@@ -117,27 +117,27 @@
 } bithenge_binary_op_t;
 
-errno_t bithenge_init_expression(bithenge_expression_t *,
+int bithenge_init_expression(bithenge_expression_t *,
     const bithenge_expression_ops_t *);
-errno_t bithenge_binary_expression(bithenge_expression_t **, bithenge_binary_op_t,
+int bithenge_binary_expression(bithenge_expression_t **, bithenge_binary_op_t,
     bithenge_expression_t *, bithenge_expression_t *);
-errno_t bithenge_in_node_expression(bithenge_expression_t **);
-errno_t bithenge_current_node_expression(bithenge_expression_t **);
-errno_t bithenge_param_expression(bithenge_expression_t **, int);
-errno_t bithenge_const_expression(bithenge_expression_t **, bithenge_node_t *);
-errno_t bithenge_scope_member_expression(bithenge_expression_t **,
+int bithenge_in_node_expression(bithenge_expression_t **);
+int bithenge_current_node_expression(bithenge_expression_t **);
+int bithenge_param_expression(bithenge_expression_t **, int);
+int bithenge_const_expression(bithenge_expression_t **, bithenge_node_t *);
+int bithenge_scope_member_expression(bithenge_expression_t **,
     bithenge_node_t *);
-errno_t bithenge_subblob_expression(bithenge_expression_t **,
+int bithenge_subblob_expression(bithenge_expression_t **,
     bithenge_expression_t *, bithenge_expression_t *, bithenge_expression_t *,
     bool);
-errno_t bithenge_param_wrapper(bithenge_transform_t **, bithenge_transform_t *,
+int bithenge_param_wrapper(bithenge_transform_t **, bithenge_transform_t *,
     bithenge_expression_t **);
-errno_t bithenge_expression_transform(bithenge_transform_t **,
+int bithenge_expression_transform(bithenge_transform_t **,
     bithenge_expression_t *);
-errno_t bithenge_inputless_transform(bithenge_transform_t **,
+int bithenge_inputless_transform(bithenge_transform_t **,
     bithenge_expression_t *);
 
-errno_t bithenge_concat_blob(bithenge_node_t **, bithenge_blob_t *,
+int bithenge_concat_blob(bithenge_node_t **, bithenge_blob_t *,
     bithenge_blob_t *);
-errno_t bithenge_concat_blob_lazy(bithenge_node_t **, bithenge_blob_t *,
+int bithenge_concat_blob_lazy(bithenge_node_t **, bithenge_blob_t *,
     bithenge_expression_t *, bithenge_scope_t *);
 
Index: uspace/lib/bithenge/include/bithenge/file.h
===================================================================
--- uspace/lib/bithenge/include/bithenge/file.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/bithenge/include/bithenge/file.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -41,7 +41,7 @@
 #include "blob.h"
 
-errno_t bithenge_new_file_blob(bithenge_node_t **, const char *);
-errno_t bithenge_new_file_blob_from_fd(bithenge_node_t **, int);
-errno_t bithenge_new_file_blob_from_file(bithenge_node_t **, FILE *);
+int bithenge_new_file_blob(bithenge_node_t **, const char *);
+int bithenge_new_file_blob_from_fd(bithenge_node_t **, int);
+int bithenge_new_file_blob_from_file(bithenge_node_t **, FILE *);
 
 #endif
Index: uspace/lib/bithenge/include/bithenge/print.h
===================================================================
--- uspace/lib/bithenge/include/bithenge/print.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/bithenge/include/bithenge/print.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -50,6 +50,6 @@
 } bithenge_print_type_t;
 
-errno_t bithenge_print_node(bithenge_print_type_t, bithenge_node_t *);
-errno_t bithenge_print_node_to_string(char **, size_t *, bithenge_print_type_t,
+int bithenge_print_node(bithenge_print_type_t, bithenge_node_t *);
+int bithenge_print_node_to_string(char **, size_t *, bithenge_print_type_t,
     bithenge_node_t *);
 
Index: uspace/lib/bithenge/include/bithenge/script.h
===================================================================
--- uspace/lib/bithenge/include/bithenge/script.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/bithenge/include/bithenge/script.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -40,5 +40,5 @@
 #include "transform.h"
 
-errno_t bithenge_parse_script(const char *, bithenge_transform_t **);
+int bithenge_parse_script(const char *, bithenge_transform_t **);
 
 #endif
Index: uspace/lib/bithenge/include/bithenge/sequence.h
===================================================================
--- uspace/lib/bithenge/include/bithenge/sequence.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/bithenge/include/bithenge/sequence.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -40,9 +40,9 @@
 #include "transform.h"
 
-errno_t bithenge_new_struct(bithenge_transform_t **,
+int bithenge_new_struct(bithenge_transform_t **,
     bithenge_named_transform_t *);
-errno_t bithenge_repeat_transform(bithenge_transform_t **, bithenge_transform_t *,
+int bithenge_repeat_transform(bithenge_transform_t **, bithenge_transform_t *,
     bithenge_expression_t *);
-errno_t bithenge_do_while_transform(bithenge_transform_t **,
+int bithenge_do_while_transform(bithenge_transform_t **,
     bithenge_transform_t *, bithenge_expression_t *);
 
Index: uspace/lib/bithenge/include/bithenge/source.h
===================================================================
--- uspace/lib/bithenge/include/bithenge/source.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/bithenge/include/bithenge/source.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -40,5 +40,5 @@
 #include "tree.h"
 
-errno_t bithenge_node_from_source(bithenge_node_t **, const char *);
+int bithenge_node_from_source(bithenge_node_t **, const char *);
 
 #endif
Index: uspace/lib/bithenge/include/bithenge/transform.h
===================================================================
--- uspace/lib/bithenge/include/bithenge/transform.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/bithenge/include/bithenge/transform.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -76,11 +76,11 @@
 typedef struct bithenge_transform_ops {
 	/** @copydoc bithenge_transform_t::bithenge_transform_apply */
-	errno_t (*apply)(bithenge_transform_t *self, bithenge_scope_t *scope,
+	int (*apply)(bithenge_transform_t *self, bithenge_scope_t *scope,
 	    bithenge_node_t *in, bithenge_node_t **out);
 	/** @copydoc bithenge_transform_t::bithenge_transform_prefix_length */
-	errno_t (*prefix_length)(bithenge_transform_t *self,
+	int (*prefix_length)(bithenge_transform_t *self,
 	    bithenge_scope_t *scope, bithenge_blob_t *blob, aoff64_t *out);
 	/** @copydoc bithenge_transform_t::bithenge_transform_prefix_apply */
-	errno_t (*prefix_apply)(bithenge_transform_t *self,
+	int (*prefix_apply)(bithenge_transform_t *self,
 	    bithenge_scope_t *scope, bithenge_blob_t *blob,
 	    bithenge_node_t **out_node, aoff64_t *out_size);
@@ -158,21 +158,21 @@
 
 /** @memberof bithenge_transform_t */
-errno_t bithenge_init_transform(bithenge_transform_t *,
+int bithenge_init_transform(bithenge_transform_t *,
     const bithenge_transform_ops_t *, int);
 /** @memberof bithenge_transform_t */
-errno_t bithenge_transform_apply(bithenge_transform_t *, bithenge_scope_t *,
+int bithenge_transform_apply(bithenge_transform_t *, bithenge_scope_t *,
     bithenge_node_t *, bithenge_node_t **);
 /** @memberof bithenge_transform_t */
-errno_t bithenge_transform_prefix_length(bithenge_transform_t *,
+int bithenge_transform_prefix_length(bithenge_transform_t *,
     bithenge_scope_t *, bithenge_blob_t *, aoff64_t *);
 /** @memberof bithenge_transform_t */
-errno_t bithenge_transform_prefix_apply(bithenge_transform_t *, bithenge_scope_t *,
+int bithenge_transform_prefix_apply(bithenge_transform_t *, bithenge_scope_t *,
     bithenge_blob_t *, bithenge_node_t **, aoff64_t *);
-errno_t bithenge_new_barrier_transform(bithenge_transform_t **, int);
-errno_t bithenge_barrier_transform_set_subtransform(bithenge_transform_t *,
+int bithenge_new_barrier_transform(bithenge_transform_t **, int);
+int bithenge_barrier_transform_set_subtransform(bithenge_transform_t *,
     bithenge_transform_t *);
 
 /** @memberof bithenge_scope_t */
-errno_t bithenge_scope_new(bithenge_scope_t **, bithenge_scope_t *);
+int bithenge_scope_new(bithenge_scope_t **, bithenge_scope_t *);
 /** @memberof bithenge_scope_t */
 void bithenge_scope_dec_ref(bithenge_scope_t *);
@@ -182,5 +182,5 @@
 const char *bithenge_scope_get_error(bithenge_scope_t *);
 /** @memberof bithenge_scope_t */
-errno_t bithenge_scope_error(bithenge_scope_t *, const char *, ...);
+int bithenge_scope_error(bithenge_scope_t *, const char *, ...);
 /** @memberof bithenge_scope_t */
 bithenge_node_t *bithenge_scope_get_current_node(bithenge_scope_t *);
@@ -196,9 +196,9 @@
 bool bithenge_scope_is_barrier(bithenge_scope_t *);
 /** @memberof bithenge_scope_t */
-errno_t bithenge_scope_alloc_params(bithenge_scope_t *, int);
-/** @memberof bithenge_scope_t */
-errno_t bithenge_scope_set_param(bithenge_scope_t *, int, bithenge_node_t *);
-/** @memberof bithenge_scope_t */
-errno_t bithenge_scope_get_param(bithenge_scope_t *, int, bithenge_node_t **);
+int bithenge_scope_alloc_params(bithenge_scope_t *, int);
+/** @memberof bithenge_scope_t */
+int bithenge_scope_set_param(bithenge_scope_t *, int, bithenge_node_t *);
+/** @memberof bithenge_scope_t */
+int bithenge_scope_get_param(bithenge_scope_t *, int, bithenge_node_t **);
 
 #endif
Index: uspace/lib/bithenge/include/bithenge/tree.h
===================================================================
--- uspace/lib/bithenge/include/bithenge/tree.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/bithenge/include/bithenge/tree.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -39,5 +39,4 @@
 
 #include <assert.h>
-#include <stdbool.h>
 #include "os.h"
 
@@ -82,12 +81,12 @@
  * @param data Data provided to @a bithenge_node_t::bithenge_node_for_each.
  * @return EOK on success or an error code from errno.h. */
-typedef errno_t (*bithenge_for_each_func_t)(bithenge_node_t *key, bithenge_node_t *value, void *data);
+typedef int (*bithenge_for_each_func_t)(bithenge_node_t *key, bithenge_node_t *value, void *data);
 
 /** Operations providing access to an internal node. */
 typedef struct bithenge_internal_node_ops_t {
 	/** @copydoc bithenge_node_t::bithenge_node_for_each */
-	errno_t (*for_each)(bithenge_node_t *self, bithenge_for_each_func_t func, void *data);
+	int (*for_each)(bithenge_node_t *self, bithenge_for_each_func_t func, void *data);
 	/** @copydoc bithenge_node_t::bithenge_node_get */
-	errno_t (*get)(bithenge_node_t *self, bithenge_node_t *key,
+	int (*get)(bithenge_node_t *self, bithenge_node_t *key,
 	    bithenge_node_t **out);
 	/** Destroys the internal node.
@@ -123,5 +122,5 @@
  * @param data Data to provide to the callback function.
  * @return EOK on success or an error code from errno.h. */
-static inline errno_t bithenge_node_for_each(bithenge_node_t *self,
+static inline int bithenge_node_for_each(bithenge_node_t *self,
     bithenge_for_each_func_t func, void *data)
 {
@@ -131,5 +130,5 @@
 
 /** @memberof bithenge_node_t */
-errno_t bithenge_node_get(bithenge_node_t *, bithenge_node_t *,
+int bithenge_node_get(bithenge_node_t *, bithenge_node_t *,
     bithenge_node_t **);
 
@@ -165,19 +164,19 @@
 
 /** @memberof bithenge_node_t */
-errno_t bithenge_init_internal_node(bithenge_node_t *,
+int bithenge_init_internal_node(bithenge_node_t *,
     const bithenge_internal_node_ops_t *);
 /** @memberof bithenge_node_t */
-errno_t bithenge_new_empty_internal_node(bithenge_node_t **);
+int bithenge_new_empty_internal_node(bithenge_node_t **);
 /** @memberof bithenge_node_t */
-errno_t bithenge_new_simple_internal_node(bithenge_node_t **, bithenge_node_t **,
+int bithenge_new_simple_internal_node(bithenge_node_t **, bithenge_node_t **,
     bithenge_int_t, bool needs_free);
 /** @memberof bithenge_node_t */
-errno_t bithenge_new_boolean_node(bithenge_node_t **, bool);
+int bithenge_new_boolean_node(bithenge_node_t **, bool);
 /** @memberof bithenge_node_t */
-errno_t bithenge_new_integer_node(bithenge_node_t **, bithenge_int_t);
+int bithenge_new_integer_node(bithenge_node_t **, bithenge_int_t);
 /** @memberof bithenge_node_t */
-errno_t bithenge_new_string_node(bithenge_node_t **, const char *, bool);
+int bithenge_new_string_node(bithenge_node_t **, const char *, bool);
 /** @memberof bithenge_node_t */
-errno_t bithenge_node_equal(bool *, bithenge_node_t *, bithenge_node_t *);
+int bithenge_node_equal(bool *, bithenge_node_t *, bithenge_node_t *);
 
 #endif
